require 'rest-client'
require 'json'

# A very simple class for RT Best Practical REST 2.0 API
# TODO: exception and more robust code
class PLM_RT
    attr_reader :status, :site, :version,  :server, :token
    def initialize(*params)
        @timeout = 240
        if params.class == Array && params[0].class == Hash
            param = params[0]
            @token = param[:token] if param.has_key? :token
            if param.has_key? :server
              @server = param[:server]
              @server += "/" if @server !~ /\/$/
              @resource = "#{@server}REST/2.0/"
            end
            @timeout = param[:timeout] if param.has_key? :timeout
            @verify_ssl = param[:verify_ssl] if param.has_key? :verify_ssl
        end
        @site = RestClient::Resource.new(
            @resource,
            read_timout: @timeout.to_i,
            open_timeout: @timeout.to_i,
            verify_ssl: @verify_ssl,
            headers: {Authorization: "token #{@token}"}
            )
    end

    def show(id)
        request = @site["ticket/#{id}"].get
    end

    def query(*params)
        query = params[0]
        order = ""
        if params.size > 1
          order = params[1]
        end
        if params[0].class == Hash
          params = params[0]
          query = params[:query] if params.has_key? :query
          order = params[:order] if params.has_key? :order
        end
        request = @site["tickets?query=#{CGI.escape(query)}&orderby=#{order}&format=l"].get
        JSON.parse(request.body)
    end

    def create(body)
        request = @site["ticket"].post JSON.generate(body), content_type: 'application/json'
        JSON.parse(request.body) if valid_json?(request.body)
    end

    def comment(field_hash)
        if field_hash.has_key? :id
            id = field_hash[:id]
          else
            raise "PLM_RT.comment requires a Ticket number in the 'id' key."
          end
        request = @site["ticket/#{id}/comment"].post field_hash[:Content], content_type: 'text/plain'
    end

    def edit(field_hash)
        if field_hash.has_key? :id
            id = field_hash[:id]
          else
            raise "PLM_RT.comment requires a Ticket number in the 'id' key."
          end
        request = @site["ticket/#{id}"].put JSON.generate(field_hash), content_type: 'application/json'
    end

    def delete(ticket)
        request = @site["ticket/#{ticket}"].delete
    end

    def valid_json?(json)
        JSON.parse(json)
        true
      rescue JSON::ParserError, TypeError => e
        false
      end
      
end
